<template>
  <div class="data-table">
    <div class="data-table__headers">
      <div class="data-table__row">
        <data-table-header fieldName="name" />
        <data-table-header fieldName="culture" />
        <data-table-header fieldName="gender" />
        <data-table-header fieldName="born" />
        <data-table-header fieldName="died" />
        <data-table-header fieldName="age" />
        <data-table-header fieldName="playedBy" title="Played by" />
        <data-table-header fieldName="aliases" />
      </div>

      <div class="data-table__filters data-table__row">
        <data-table-filter fieldName="name" />
        <data-table-filter fieldName="culture" />
        <data-table-filter fieldName="gender" />
        <data-table-filter fieldName="born" />
        <data-table-filter fieldName="died" />
        <div class="data-table__cell">
          <!-- age -->
        </div>
        <div class="data-table__cell">
          <!-- playedBy -->
        </div>
        <div class="data-table__cell">
          <!-- aliases -->
        </div>
      </div>
    </div>

    <ul v-if="activeCharacters.length" class="data-table__list">
      <li class="data-table__item data-table__row" v-for="char in activeCharacters" :key="char.id">
        <span class="data-table__cell">{{ char.name }}</span>
        <span class="data-table__cell">{{ char.culture }}</span>
        <span class="data-table__cell">{{ char.gender }}</span>
        <span class="data-table__cell">{{ char.born }}</span>
        <span class="data-table__cell">{{ char.died }}</span>
        <span class="data-table__cell">{{ char.age ? char.age : '' }}</span>
        <span class="data-table__cell">{{ char.playedBy }}</span>
        <span class="data-table__cell">{{ char.aliases }}</span>
      </li>
    </ul>

    <div v-if="!activeCharacters.length && !isLoading" class="data-table__empty data-table-empty">
      <template v-if="isError">
        <h3 class="data-table-empty__title">
          We're sorry, but an error has occured.
        </h3>
        <app-button :is-small="true" @button-click="retryDataFetch">Try again</app-button>
      </template>

      <template v-else>
        <h3 class="data-table-empty__title">
          Sorry, but no GOT characters were found.
        </h3>
      </template>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapActions, mapGetters, mapState } from 'vuex';
import { AppMode } from '@/types';

// Components
import DataTableFilter from '@/components/DataTable/DataTableFilter.vue';
import DataTableHeader from '@/components/DataTable/DataTableHeader.vue';
import AppButton from '../AppButton.vue';

export default Vue.extend({
  name: 'DataTable',

  components: {
    DataTableFilter,
    DataTableHeader,
    AppButton
  },

  computed: {
    ...mapGetters([
      'activeCharacters'
    ]),

    ...mapState({
      appMode: (state: any) => state.global.appMode as AppMode,
      isLoading: (state: any) => state.global.isLoading as boolean,
      isError: (state: any) => state.global.isError as boolean
    })
  },

  methods: {
    ...mapActions([
      'getAllCharacters',
      'getCharacters'
    ]),

    retryDataFetch ():void {
      if (this.appMode === AppMode.live) {
        this.getCharacters();
      } else {
        this.getAllCharacters();
      }
    }
  }
});
</script>

<style lang="scss">
.data-table {
  &__headers {
    margin-bottom: .5rem;
  }

  &__row {
    display: flex;
    gap: .5rem;
    border-radius: 2px;

    &:nth-child(odd):not(.data-table__headers) {
      background: var(--color-light);
    }
  }

  &__cell {
    display: flex;
    align-items: center;
    justify-content: space-between;
    width: 12.5%;
    padding: .5rem;
  }

  &__empty {
    margin-top: 3rem;
    text-align: center;
  }
}

.data-table-empty {
  text-align: center;

  &__title {
    margin-bottom: 1rem;
  }
}
</style>
